' Keyboard constants
CONST KEYDOWN& = &H5000
CONST KEYUP& = &H4800
CONST KEYLEFT& = &H4B00
CONST KEYRIGHT& = &H4D00
CONST KEYq& = &H71
CONST KEYESCAPE& = &H1B
' Other constants
CONST TRUE = 1
CONST FALSE = 0

' Main object type:def
TYPE ObjectType
	X          AS SINGLE
	Y          AS SINGLE
	Speed      AS SINGLE
	Frame      AS INTEGER
	Direction  AS INTEGER
	Move       AS INTEGER
	Attack     AS INTEGER
	Alive      AS INTEGER
END TYPE

DIM SHARED background1 AS LONG ' will be used to store the background image
DIM SHARED WarriorSprites AS LONG ' will be used to store player sprites

DIM SHARED Player AS ObjectType ' main player
DIM SHARED Frame1 AS INTEGER, Frame2 AS INTEGER ' used to enable animation

Player.X = 100 ' Starting player's position and frame
Player.Y = 100
Player.Speed = 2      ' Always make sure to initiate
Player.Direction = 1  ' starting values to avoid errors
Player.Frame = 1      ' in the first loop.

SCREEN _NEWIMAGE(640, 480, 256) ' Sets the graphic mode
_MOUSEHIDE ' hide the mouse cursor

' Load background image, copy the palette from the image
background1 = _LOADIMAGE("BACKGRND.bmp", 256)
_COPYPALETTE background1, 0
' Load player sprites, set the transparent color
WarriorSprites = _LOADIMAGE("SPRITES.bmp")
_CLEARCOLOR 0, WarriorSprites

DO

	_LIMIT 60 ' limit FPS to 60

	' Player.Direction = 1 -> warrior moving right
	' Player.Direction = 2 -> warrior moving left
	' Player.Direction = 3 -> warrior moving down
	' Player.Direction = 4 -> warrior moving up

	Player.Move = FALSE ' By deafult the player is not
						' moving.
						
	' According to pushed key move the
	' player and flag the proper direction.
	IF _KEYDOWN(KEYRIGHT&) THEN 
		Player.X = Player.X + Player.Speed
		Player.Direction = 1
		Player.Move = TRUE
	END IF
	IF _KEYDOWN(KEYLEFT&) THEN 
		Player.X = Player.X - Player.Speed
		Player.Direction = 2
		Player.Move = TRUE
	END IF
	IF _KEYDOWN(KEYDOWN&) THEN 
		Player.Y = Player.Y + Player.Speed
		Player.Direction = 3
		Player.Move = TRUE
	END IF
	IF _KEYDOWN(KEYUP&) THEN 
		Player.Y = Player.Y - Player.Speed
		Player.Direction = 4
		Player.Move = TRUE
	END IF

	IF Player.X < 0 THEN 
		Player.Move = FALSE
		Player.X = 0
	END IF
	IF Player.X > 600 THEN 
		Player.Move = FALSE
		Player.X = 600
	END IF
	IF Player.Y < 0 THEN 
		Player.Move = FALSE
		Player.Y = 0
	END IF
	IF Player.Y > 440 THEN 
		Player.Move = FALSE
		Player.Y = 440
	END IF

	' Frame1 is used to animate the player
	' Frame2 is used to control/set after how many loops
	' Frame1 should switch from 1 to 2 and vice versa
	Frame2 = (Frame2 MOD 12) + 1
	IF Frame2 = 10 THEN Frame1 = (Frame1 MOD 2) + 1
	IF Player.Move = FALSE OR Frame1 = 0 THEN Frame1 = 1

	' According to player's direction flag the 
	' proper sprite (check in the tutorial on which
	' position each sprite is stored).
	IF Player.Direction = 1 THEN Player.Frame = 6 + Frame1
	IF Player.Direction = 2 THEN Player.Frame = 4 + Frame1
	IF Player.Direction = 3 THEN Player.Frame = 0 + Frame1
	IF Player.Direction = 4 THEN Player.Frame = 2 + Frame1

	_PUTIMAGE (0,0), background1, 0 ' paste background on 0,0 on the screen (last paremeter)

    ' Paste the proper player sprite (using player.frame) on player.x and player.y
	_PUTIMAGE (Player.X, Player.Y), WarriorSprites, 0, ((Player.Frame-1)*40, 0)-(39+(Player.Frame-1)*40, 39)

	_DISPLAY

LOOP UNTIL _KEYDOWN(KEYq&) OR _KEYDOWN(KEYESCAPE&) ' Loop until the user presses Q or ESCAPE

